
package jp.gr.java_conf.koto.ltntpnuts;

import java.util.*;
import java.io.*;
import org.apache.tools.ant.*;
import pnuts.lang.*;
import pnuts.lang.Package;

public class LTntPnuts extends Task {
    private StringBuffer script = null;
    public void addText(String text) {
        if (script == null)
            script = new StringBuffer();
        script.append(text);
    }
    
    public void importProperties(Package p, Context context, Hashtable owners, Project owner, Hashtable dictionary) {
        Enumeration e = dictionary.keys();
        while (e.hasMoreElements()) {
            String key = (String) e.nextElement();
            p.set(key.intern(), dictionary.get(key), context);
            if (owner == null)
                owners.remove(key);
            else
                owners.put(key, owner);
        }
    }
    public void execute() throws BuildException {
        Project project = getOwningTarget().getProject();
        //String script = ProjectHelper.replaceProperties(project, this.script.toString(), project.getProperties());
        final String script = this.script.toString();
        
        final Hashtable owners = new Hashtable();
        Package p = new Package("ltntpnuts") {
            public void set(String symbol, Object obj, Context context) {
                symbol = symbol.intern();
                super.set(symbol, obj, context);
                
                Project owner = (Project) owners.get(symbol);
                if (owner != null)
                    owner.setProperty(symbol, obj.toString());
            }
        };
        final Context context = new Context();
        context.setCurrentPackage(p);
        p.set("task", this, context);
        p.set("ltntpnuts.task", this, context);
        importProperties(p, context, owners, project, project.getProperties());
        //Pnuts.eval("function ant(name) { anttask = package().get(\"ltntpnuts.task\".intern(), getContext()).getOwningTarget().getProject().createTask(\"ant\"); anttask.setTarget(name); anttask.execute(); }", context);
        Pnuts.eval(script, context);
    }
}

